//+------------------------------------------------------------------+
//|                                  FastNewASCTrend1RAVI_Expert.mq4 |
//|                             Copyright  2006,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Nikolay Kositsin"
#property link "farria@mail.redcom.ru"
//----  
extern int RAVI_Timeframe = 240;
extern int ASCT_Timeframe = 1440;
//----   ר 
extern int Buy_Sell_Custom = 2; // 0-Buy, 1-Sell, 2-Buy+Sell
//----     BUY  
extern double Money_Management_Up = 0.1;
extern int RISK_Up = 3;
extern int Period1_Up = 7; 
extern int Period2_Up = 65; 
extern int MA_Metod_Up = 0;
extern int PRICE_Up = 0;
extern int STOPLOSS_Up = 50;
extern int TAKEPROFIT_Up = 100;
//----     SELL  
extern double Money_Management_Dn = 0.1;
extern int RISK_Dn = 3;
extern int Period1_Dn = 7; 
extern int Period2_Dn = 65; 
extern int MA_Metod_Dn = 0;
extern int PRICE_Dn = 0;
extern int STOPLOSS_Dn = 50;
extern int TAKEPROFIT_Dn = 100;
//----   
double RAVI_Up[4];
double RAVI_Dn[4];
double ASCTrend1_Up[4];
double ASCTrend1_Dn[4];
//----+     
double ASCTrend1_Buffer[2][2];
//+------------------------------------------------------------------+
//|                                                Get_ASCTrend1.mqh |
//|                        Copyright  2006,        Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru |
//+------------------------------------------------------------------+
bool Get_ASCTrend1(int Number, string symbol,int timeframe, 
                   bool NullBarRecount, int RISK)
  {
//----     
   int IBARS = iBars(symbol, timeframe);  
//----        
   if((IBARS < 3 + RISK*2 + 1) || (IBARS < 10))
       return(false);
//----+     
   static double x1[], x2[];
   static int IndCounted[]; 
//----+    
   if(ArraySize(IndCounted) < Number + 1)
     {
       ArrayResize(x1, Number + 1); 
       ArrayResize(x2, Number + 1); 
       ArrayResize(IndCounted, Number + 1); 
       ArrayResize(ASCTrend1_Buffer, Number + 1); 
     }
 //----+   
   int LastCountBar;
//----+     
   if(!NullBarRecount)
       LastCountBar = 1;
//----+      
   double value1, value2, value3, val1, val2;
   double TrueCount, Range, AvgRange, MRO1, MRO2;
//----+         
   int MaxBar, iii, kkk, bar, value10, value11, 
       counted_bars = IndCounted[Number];
//----+     
   IndCounted[Number] = IBARS - 1;
//----  
   value10 = 3 + RISK*2;
//----     , 
//            
   bar = IBARS - counted_bars - 1; 
//----     , 
//            
   MaxBar = IBARS - 1 - value10;
//----   
   if(bar > MaxBar)
     {
       bar = MaxBar;
       x1[Number] = 67 + RISK;
       x2[Number] = 33 - RISK;
       //----
       ArrayInitialize(ASCTrend1_Buffer, 0.0); 
     } 
//----   ר 
   while(bar >= LastCountBar)
     {  
       Range = 0.0;
       AvgRange = 0.0;
       for(iii = 0; iii <= 9; iii++) 
           AvgRange += MathAbs(iHigh(symbol, timeframe, bar + iii) -
                               iLow(symbol, timeframe, bar + iii));
	      //----
       Range=AvgRange / 10;
       iii = 0;
       TrueCount = 0;
       while(iii < 9 && TrueCount < 1)
	        {
	          if(MathAbs(iOpen(symbol, timeframe, bar + iii) - 
	                     iClose(symbol, timeframe, bar + iii)) >= 
	                     Range*2.0) 
	              TrueCount++;
	          //----
	          iii++;
	        }
       if(TrueCount >= 1)
           MRO1 = bar + iii; 
       else 
           MRO1 = -1;
       //----
       iii = 0;
       TrueCount = 0;
       while(iii < 6 && TrueCount < 1)
         {
           if(MathAbs(iClose(symbol, timeframe, bar + iii + 3) - 
                      iClose(symbol, timeframe, bar + iii)) >= 
                      Range*4.6) 
               TrueCount++;
	          //----
	          iii++;
         }
       if(TrueCount >= 1)
           MRO2 = bar + iii; 
       else 
           MRO2 = -1;
       //----
       if(MRO1 > -1)
           value11 = 3; 
       else 
           value11 = value10;
       if(MRO2 > -1)
           value11 = 4; 
       else 
           value11 = value10;
       //----
       value2 = 100 - MathAbs(iWPR(symbol, timeframe, value11, bar));
       //---- 
       val1 = 0;
       val2 = 0;
       //---- 
       if(value2 > x1[Number])
         {
           val1 = iLow (symbol, timeframe, bar);
           val2 = iHigh(symbol, timeframe, bar);
         }
       if(value2 < x2[Number])
         {
           val1 = iHigh(symbol, timeframe, bar);
           val2 = iLow (symbol, timeframe, bar);
         } 
       //----
       if(bar == 1) 
           ASCTrend1_Buffer[Number][1] = val2 - val1;
       //----
       if(bar == 0)
           ASCTrend1_Buffer[Number][0] = val2 - val1;
       bar--;
     }
//----+  
   return(true);
  }
//----+     
double RAVI_Buffer[4][5];
//+------------------------------------------------------------------+
//|                                                     Get_RAVI.mqh |
//|                        Copyright  2006,        Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru |
//+------------------------------------------------------------------+
bool Get_RAVI(int Number, string symbol,int timeframe, 
              bool NullBarRecount, int Period1, int Period2, 
              int MA_Metod,  int  PRICE)
  {
//----     
   int IBARS = iBars(symbol, timeframe);  
//----        
   if(IBARS < MathMax(Period1, Period2))
       return(false);
//----+     
   static int IndCounted[]; 
//----+    
   if(ArraySize(IndCounted) < Number+1)
     {
       ArrayResize(IndCounted, Number + 1); 
       //----
       ArrayResize(RAVI_Buffer,Number + 1); 
     }
//----+   
   int LastCountBar;
//----+     
   if(!NullBarRecount)
       LastCountBar = 1;
//----+      
   double MA1, MA2, result; 
//----+         
   int MaxBar, bar, limit, counted_bars = IndCounted[Number];
//----+     
   IndCounted[Number] = IBARS - 1;
//----     , 
//            
   limit = IBARS - counted_bars - 1;
//----     , 
//            
   MaxBar = IBARS - 1 - MathMax(Period1, Period2); 
//----   
   if(limit > MaxBar)
     {
       limit=MaxBar;
       ArrayInitialize(RAVI_Buffer, 0.0);
     } 
//----+     
   for(bar = limit; bar >= LastCountBar; bar--)
     { 
       MA1 = iMA(symbol, timeframe, Period1, 0, MA_Metod, PRICE, bar); 
       MA2 = iMA(symbol, timeframe, Period2, 0, MA_Metod, PRICE,bar); 
       //---- 
       result = ((MA1 - MA2) / MA2)*100; 
       //---- 
       if((bar > 0) && (bar <= 4))
         { 
           RAVI_Buffer[Number][4] = RAVI_Buffer[Number][3];
           RAVI_Buffer[Number][3] = RAVI_Buffer[Number][2];
           RAVI_Buffer[Number][2] = RAVI_Buffer[Number][1];	    	    
           RAVI_Buffer[Number][1] = result;
         }
	      //----
	      if(bar == 0)
	          RAVI_Buffer[Number][0] = result; 	 
     } 
//----+  
   return(true);
  }
//+------------------------------------------------------------------+
//| Custom Expert functions                                          |
//+------------------------------------------------------------------+
#include <Lite_EXPERT.mqh>
//+------------------------------------------------------------------+
//| Custom Expert initialization function                            |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   if(RAVI_Timeframe != 1)
       if(RAVI_Timeframe != 5)
           if(RAVI_Timeframe != 15)
               if(RAVI_Timeframe != 30)
                   if(RAVI_Timeframe != 60)
                       if(RAVI_Timeframe != 240)
                           if(RAVI_Timeframe != 1440)
                               Print(" RAVI_Timeframe  " + 
                                     "   " + RAVI_Timeframe + "!!!");
//---- 
   if(ASCT_Timeframe != 1)
       if(ASCT_Timeframe != 5)
           if(ASCT_Timeframe != 15)
               if(ASCT_Timeframe != 30)
                   if(ASCT_Timeframe != 60)
                       if(ASCT_Timeframe != 240)
                           if(ASCT_Timeframe != 1440)
                               Print(" ASCT_Timeframe  " + 
                                     "   " + ASCT_Timeframe + "!!!");
//----                      
   if(RAVI_Timeframe > ASCT_Timeframe) 
       Print(" ASCT_Timeframe      RAVI_Timeframe");                   
//----  
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom Expert iteration function                                 |
//+------------------------------------------------------------------+
int start()
  {
//----          
   if(iBars(NULL, ASCT_Timeframe) < 3 + RISK_Up*2 + 1 + 1)
       return(0);
   if(iBars(NULL, ASCT_Timeframe) < 3 + RISK_Dn*2 + 1 + 1)
       return(0);
//----
   if(iBars(NULL, RAVI_Timeframe) < MathMax(Period1_Up, Period2_Up + 4))
       return(0);
   if (iBars(NULL,RAVI_Timeframe)<MathMax(Period1_Dn,Period2_Dn+4))
       return(0);
//----       
   static int LastBars;
//----      
   bool BUY_Sign, SELL_Sign;
//----   
   int bar;
//----        
   if(LastBars != iBars(NULL, RAVI_Timeframe))
       switch(Buy_Sell_Custom)
         {
           case 0: 
             {
               Get_RAVI(0, Symbol(), RAVI_Timeframe, false, Period1_Up, 
                        Period2_Up, MA_Metod_Up, PRICE_Up);
               for(bar = 3; bar >= 0; bar--)
                   RAVI_Up[bar] = RAVI_Buffer[0][bar];
               //----
               Get_ASCTrend1(0, Symbol(), ASCT_Timeframe, false, RISK_Up); 
               ASCTrend1_Up[1] = ASCTrend1_Buffer[0][1]; 
               break;
             }
           case 1: 
             {            
               Get_RAVI(1, Symbol(), RAVI_Timeframe, false, Period1_Dn, 
                        Period2_Dn, MA_Metod_Dn, PRICE_Dn);
               for(bar = 3; bar >= 0; bar--)
                   RAVI_Dn[bar] = RAVI_Buffer[1][bar];
               //----
               Get_ASCTrend1(1, Symbol(), ASCT_Timeframe, false, RISK_Dn); 
               ASCTrend1_Dn[1] = ASCTrend1_Buffer[1][1]; 
               break;
             }
           default:
             {
               Get_RAVI(0, Symbol(), RAVI_Timeframe, false, Period1_Up, 
                        Period2_Up, MA_Metod_Up, PRICE_Up);
               for(bar = 3; bar >= 0; bar--)
                   RAVI_Up[bar] = RAVI_Buffer[0][bar];
               //----
               Get_ASCTrend1(0, Symbol(), ASCT_Timeframe, false, RISK_Up);
               ASCTrend1_Up[1] = ASCTrend1_Buffer[0][1];  
               //----              
               Get_RAVI(1, Symbol(), RAVI_Timeframe, false, Period1_Dn, 
                        Period2_Dn, MA_Metod_Dn, PRICE_Dn);
               for(bar = 3; bar >= 0; bar--)
                   RAVI_Dn[bar] = RAVI_Buffer[1][bar];
               //----
               Get_ASCTrend1(1, Symbol(), ASCT_Timeframe, false, RISK_Dn); 
               ASCTrend1_Dn[1] = ASCTrend1_Buffer[1][1]; 
         }
     }
//----  
   LastBars = iBars(NULL, RAVI_Timeframe);
//----    
   switch(Buy_Sell_Custom)
     {
       case 0: 
         {
           if(RAVI_Up[2] - RAVI_Up[3] < 0)
               if(RAVI_Up[1] - RAVI_Up[2] > 0)
                   if(ASCTrend1_Up[1] > 0)
                       BUY_Sign = true;
           break;
         }
       case 1: 
         {
           if(RAVI_Dn[2] - RAVI_Dn[3] > 0)
               if(RAVI_Dn[1] - RAVI_Dn[2] < 0)
                   if(ASCTrend1_Dn[1] < 0)
                       SELL_Sign = true;
           break;
         }
       default:
         {
           if(RAVI_Up[2] - RAVI_Up[3] < 0)
               if(RAVI_Up[1] - RAVI_Up[2] > 0)
                   if(ASCTrend1_Up[1] > 0)
                       BUY_Sign = true;
           //----+                  
           if(RAVI_Dn[2] - RAVI_Dn[3] > 0)
               if(RAVI_Dn[1] - RAVI_Dn[2] < 0)
                   if(ASCTrend1_Dn[1] < 0)
                       SELL_Sign = true;
         }
     }
//----  
   switch(Buy_Sell_Custom)
     {
       case 0: 
         {
           OpenBuyOrder(BUY_Sign, Money_Management_Up, STOPLOSS_Up, TAKEPROFIT_Up);
           break;
         }
       case 1: 
         {
           OpenSellOrder(SELL_Sign, Money_Management_Dn, STOPLOSS_Dn, TAKEPROFIT_Dn);
           break;
         }
       default:
         {
           OpenBuyOrder(BUY_Sign, Money_Management_Up, STOPLOSS_Up, TAKEPROFIT_Up);
           OpenSellOrder(SELL_Sign, Money_Management_Dn, STOPLOSS_Dn, TAKEPROFIT_Dn);
         }
     }
   return(0);
  }
//+------------------------------------------------------------------+